
#include "rwlock.h"

namespace test {

    struct Data {
        int A;
        int B;
        int C;
        Data( int a, int b, int c ) :
            A( a ),
            B( b ),
            C( c )
        {}
    };

    class Reader {
        RWlock &_lock;
        Data &_data;
    public:
    
        Reader( RWlock &l, Data &d ) :
            _lock( l ),
            _data( d )
        {}
        
        void operator()();
    };

    class Writer {
        RWlock &_lock;
        Data &_data;
    public:
    
        Writer( RWlock &l, Data &d ) :
            _lock( l ),
            _data( d )
        {}
        
        void operator()( int id );
    };
    
    
    void run();
}
